Fix a "label defined but unreferenced" warning.
[git.git] / git-commit.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
5
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]'
7 SUBDIRECTORY_OK=Yes
8 . git-sh-setup
9 require_work_tree
10
11 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
12
13 case "$0" in
14 *status)
15         status_only=t
16         unmerged_ok_if_status=--unmerged ;;
17 *commit)
18         status_only=
19         unmerged_ok_if_status= ;;
20 esac
21
22 refuse_partial () {
23         echo >&2 "$1"
24         echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
25         exit 1
26 }
27
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
30 rm -f "$NEXT_INDEX"
31 save_index () {
32         cp -p "$THIS_INDEX" "$NEXT_INDEX"
33 }
34
35 run_status () {
36         # If TMP_INDEX is defined, that means we are doing
37         # "--only" partial commit, and that index file is used
38         # to build the tree for the commit.  Otherwise, if
39         # NEXT_INDEX exists, that is the index file used to
40         # make the commit.  Otherwise we are using as-is commit
41         # so the regular index file is what we use to compare.
42         if test '' != "$TMP_INDEX"
43         then
44                 GIT_INDEX_FILE="$TMP_INDEX"
45                 export GIT_INDEX_FILE
46         elif test -f "$NEXT_INDEX"
47         then
48                 GIT_INDEX_FILE="$NEXT_INDEX"
49                 export GIT_INDEX_FILE
50         fi
51
52         case "$status_only" in
53         t) color= ;;
54         *) color=--nocolor ;;
55         esac
56         git-runstatus ${color} \
57                 ${verbose:+--verbose} \
58                 ${amend:+--amend} \
59                 ${untracked_files:+--untracked}
60 }
61
62 trap '
63         test -z "$TMP_INDEX" || {
64                 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
65         }
66         rm -f "$NEXT_INDEX"
67 ' 0
68
69 ################################################################
70 # Command line argument parsing and sanity checking
71
72 all=
73 also=
74 only=
75 logfile=
76 use_commit=
77 amend=
78 edit_flag=
79 no_edit=
80 log_given=
81 log_message=
82 verify=t
83 quiet=
84 verbose=
85 signoff=
86 force_author=
87 only_include_assumed=
88 untracked_files=
89 while case "$#" in 0) break;; esac
90 do
91         case "$1" in
92         -F|--F|-f|--f|--fi|--fil|--file)
93                 case "$#" in 1) usage ;; esac
94                 shift
95                 no_edit=t
96                 log_given=t$log_given
97                 logfile="$1"
98                 shift
99                 ;;
100         -F*|-f*)
101                 no_edit=t
102                 log_given=t$log_given
103                 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
104                 shift
105                 ;;
106         --F=*|--f=*|--fi=*|--fil=*|--file=*)
107                 no_edit=t
108                 log_given=t$log_given
109                 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
110                 shift
111                 ;;
112         -a|--a|--al|--all)
113                 all=t
114                 shift
115                 ;;
116         --au=*|--aut=*|--auth=*|--autho=*|--author=*)
117                 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
118                 shift
119                 ;;
120         --au|--aut|--auth|--autho|--author)
121                 case "$#" in 1) usage ;; esac
122                 shift
123                 force_author="$1"
124                 shift
125                 ;;
126         -e|--e|--ed|--edi|--edit)
127                 edit_flag=t
128                 shift
129                 ;;
130         -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
131                 also=t
132                 shift
133                 ;;
134         -o|--o|--on|--onl|--only)
135                 only=t
136                 shift
137                 ;;
138         -m|--m|--me|--mes|--mess|--messa|--messag|--message)
139                 case "$#" in 1) usage ;; esac
140                 shift
141                 log_given=m$log_given
142                 if test "$log_message" = ''
143                 then
144                     log_message="$1"
145                 else
146                     log_message="$log_message
147
148 $1"
149                 fi
150                 no_edit=t
151                 shift
152                 ;;
153         -m*)
154                 log_given=m$log_given
155                 if test "$log_message" = ''
156                 then
157                     log_message=`expr "z$1" : 'z-m\(.*\)'`
158                 else
159                     log_message="$log_message
160
161 `expr "z$1" : 'z-m\(.*\)'`"
162                 fi
163                 no_edit=t
164                 shift
165                 ;;
166         --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
167                 log_given=m$log_given
168                 if test "$log_message" = ''
169                 then
170                     log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
171                 else
172                     log_message="$log_message
173
174 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
175                 fi
176                 no_edit=t
177                 shift
178                 ;;
179         -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
180         --no-verify)
181                 verify=
182                 shift
183                 ;;
184         --a|--am|--ame|--amen|--amend)
185                 amend=t
186                 log_given=t$log_given
187                 use_commit=HEAD
188                 shift
189                 ;;
190         -c)
191                 case "$#" in 1) usage ;; esac
192                 shift
193                 log_given=t$log_given
194                 use_commit="$1"
195                 no_edit=
196                 shift
197                 ;;
198         --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
199         --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
200         --reedit-messag=*|--reedit-message=*)
201                 log_given=t$log_given
202                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
203                 no_edit=
204                 shift
205                 ;;
206         --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
207         --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
208         --reedit-message)
209                 case "$#" in 1) usage ;; esac
210                 shift
211                 log_given=t$log_given
212                 use_commit="$1"
213                 no_edit=
214                 shift
215                 ;;
216         -C)
217                 case "$#" in 1) usage ;; esac
218                 shift
219                 log_given=t$log_given
220                 use_commit="$1"
221                 no_edit=t
222                 shift
223                 ;;
224         --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
225         --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
226         --reuse-message=*)
227                 log_given=t$log_given
228                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
229                 no_edit=t
230                 shift
231                 ;;
232         --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
233         --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
234                 case "$#" in 1) usage ;; esac
235                 shift
236                 log_given=t$log_given
237                 use_commit="$1"
238                 no_edit=t
239                 shift
240                 ;;
241         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
242                 signoff=t
243                 shift
244                 ;;
245         -q|--q|--qu|--qui|--quie|--quiet)
246                 quiet=t
247                 shift
248                 ;;
249         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
250                 verbose=t
251                 shift
252                 ;;
253         -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
254         --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
255         --untracked-file|--untracked-files)
256                 untracked_files=t
257                 shift
258                 ;;
259         --)
260                 shift
261                 break
262                 ;;
263         -*)
264                 usage
265                 ;;
266         *)
267                 break
268                 ;;
269         esac
270 done
271 case "$edit_flag" in t) no_edit= ;; esac
272
273 ################################################################
274 # Sanity check options
275
276 case "$amend,$initial_commit" in
277 t,t)
278         die "You do not have anything to amend." ;;
279 t,)
280         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
281                 die "You are in the middle of a merge -- cannot amend."
282         fi ;;
283 esac
284
285 case "$log_given" in
286 tt*)
287         die "Only one of -c/-C/-F/--amend can be used." ;;
288 *tm*|*mt*)
289         die "Option -m cannot be combined with -c/-C/-F/--amend." ;;
290 esac
291
292 case "$#,$also,$only,$amend" in
293 *,t,t,*)
294         die "Only one of --include/--only can be used." ;;
295 0,t,,* | 0,,t,)
296         die "No paths with --include/--only does not make sense." ;;
297 0,,t,t)
298         only_include_assumed="# Clever... amending the last one with dirty index." ;;
299 0,,,*)
300         ;;
301 *,,,*)
302         only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
303         also=
304         ;;
305 esac
306 unset only
307 case "$all,$also,$#" in
308 t,t,*)
309         die "Cannot use -a and -i at the same time." ;;
310 t,,[1-9]*)
311         die "Paths with -a does not make sense." ;;
312 ,t,0)
313         die "No paths with -i does not make sense." ;;
314 esac
315
316 ################################################################
317 # Prepare index to have a tree to be committed
318
319 case "$all,$also" in
320 t,)
321         if test ! -f "$THIS_INDEX"
322         then
323                 die 'nothing to commit (use "git add file1 file2" to include for commit)'
324         fi
325         save_index &&
326         (
327                 cd_to_toplevel &&
328                 GIT_INDEX_FILE="$NEXT_INDEX" &&
329                 export GIT_INDEX_FILE &&
330                 git-diff-files --name-only -z |
331                 git-update-index --remove -z --stdin
332         ) || exit
333         ;;
334 ,t)
335         save_index &&
336         git-ls-files --error-unmatch -- "$@" >/dev/null || exit
337
338         git-diff-files --name-only -z -- "$@"  |
339         (
340                 cd_to_toplevel &&
341                 GIT_INDEX_FILE="$NEXT_INDEX" &&
342                 export GIT_INDEX_FILE &&
343                 git-update-index --remove -z --stdin
344         ) || exit
345         ;;
346 ,)
347         case "$#" in
348         0)
349                 ;; # commit as-is
350         *)
351                 if test -f "$GIT_DIR/MERGE_HEAD"
352                 then
353                         refuse_partial "Cannot do a partial commit during a merge."
354                 fi
355                 TMP_INDEX="$GIT_DIR/tmp-index$$"
356                 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
357
358                 # Build a temporary index and update the real index
359                 # the same way.
360                 if test -z "$initial_commit"
361                 then
362                         cp "$THIS_INDEX" "$TMP_INDEX"
363                         GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
364                 else
365                         rm -f "$TMP_INDEX"
366                 fi || exit
367
368                 echo "$commit_only" |
369                 GIT_INDEX_FILE="$TMP_INDEX" \
370                 git-update-index --add --remove --stdin &&
371
372                 save_index &&
373                 echo "$commit_only" |
374                 (
375                         GIT_INDEX_FILE="$NEXT_INDEX"
376                         export GIT_INDEX_FILE
377                         git-update-index --remove --stdin
378                 ) || exit
379                 ;;
380         esac
381         ;;
382 esac
383
384 ################################################################
385 # If we do as-is commit, the index file will be THIS_INDEX,
386 # otherwise NEXT_INDEX after we make this commit.  We leave
387 # the index as is if we abort.
388
389 if test -f "$NEXT_INDEX"
390 then
391         USE_INDEX="$NEXT_INDEX"
392 else
393         USE_INDEX="$THIS_INDEX"
394 fi
395
396 GIT_INDEX_FILE="$USE_INDEX" \
397         git-update-index -q $unmerged_ok_if_status --refresh || exit
398
399 ################################################################
400 # If the request is status, just show it and exit.
401
402 case "$0" in
403 *status)
404         run_status
405         exit $?
406 esac
407
408 ################################################################
409 # Grab commit message, write out tree and make commit.
410
411 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
412 then
413         if test "$TMP_INDEX"
414         then
415                 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
416         else
417                 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
418         fi || exit
419 fi
420
421 if test "$log_message" != ''
422 then
423         echo "$log_message"
424 elif test "$logfile" != ""
425 then
426         if test "$logfile" = -
427         then
428                 test -t 0 &&
429                 echo >&2 "(reading log message from standard input)"
430                 cat
431         else
432                 cat <"$logfile"
433         fi
434 elif test "$use_commit" != ""
435 then
436         encoding=$(git config i18n.commitencoding || echo UTF-8)
437         git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
438         sed -e '1,/^$/d' -e 's/^    //'
439 elif test -f "$GIT_DIR/MERGE_MSG"
440 then
441         cat "$GIT_DIR/MERGE_MSG"
442 elif test -f "$GIT_DIR/SQUASH_MSG"
443 then
444         cat "$GIT_DIR/SQUASH_MSG"
445 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
446
447 case "$signoff" in
448 t)
449         need_blank_before_signoff=
450         tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
451         grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes
452         {
453                 test -z "$need_blank_before_signoff" || echo
454                 git-var GIT_COMMITTER_IDENT | sed -e '
455                         s/>.*/>/
456                         s/^/Signed-off-by: /
457                 '
458         } >>"$GIT_DIR"/COMMIT_EDITMSG
459         ;;
460 esac
461
462 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
463         echo "#"
464         echo "# It looks like you may be committing a MERGE."
465         echo "# If this is not correct, please remove the file"
466         echo "# $GIT_DIR/MERGE_HEAD"
467         echo "# and try again"
468         echo "#"
469 fi >>"$GIT_DIR"/COMMIT_EDITMSG
470
471 # Author
472 if test '' != "$use_commit"
473 then
474         pick_author_script='
475         /^author /{
476                 s/'\''/'\''\\'\'\''/g
477                 h
478                 s/^author \([^<]*\) <[^>]*> .*$/\1/
479                 s/'\''/'\''\'\'\''/g
480                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
481
482                 g
483                 s/^author [^<]* <\([^>]*\)> .*$/\1/
484                 s/'\''/'\''\'\'\''/g
485                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
486
487                 g
488                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
489                 s/'\''/'\''\'\'\''/g
490                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
491
492                 q
493         }
494         '
495         encoding=$(git config i18n.commitencoding || echo UTF-8)
496         set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
497         LANG=C LC_ALL=C sed -ne "$pick_author_script"`
498         eval "$set_author_env"
499         export GIT_AUTHOR_NAME
500         export GIT_AUTHOR_EMAIL
501         export GIT_AUTHOR_DATE
502 fi
503 if test '' != "$force_author"
504 then
505         GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
506         GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
507         test '' != "$GIT_AUTHOR_NAME" &&
508         test '' != "$GIT_AUTHOR_EMAIL" ||
509         die "malformed --author parameter"
510         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
511 fi
512
513 PARENTS="-p HEAD"
514 if test -z "$initial_commit"
515 then
516         rloga='commit'
517         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
518                 rloga='commit (merge)'
519                 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
520         elif test -n "$amend"; then
521                 rloga='commit (amend)'
522                 PARENTS=$(git-cat-file commit HEAD |
523                         sed -n -e '/^$/q' -e 's/^parent /-p /p')
524         fi
525         current="$(git-rev-parse --verify HEAD)"
526 else
527         if [ -z "$(git-ls-files)" ]; then
528                 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
529                 exit 1
530         fi
531         PARENTS=""
532         rloga='commit (initial)'
533         current=''
534 fi
535 set_reflog_action "$rloga"
536
537 if test -z "$no_edit"
538 then
539         {
540                 echo ""
541                 echo "# Please enter the commit message for your changes."
542                 echo "# (Comment lines starting with '#' will not be included)"
543                 test -z "$only_include_assumed" || echo "$only_include_assumed"
544                 run_status
545         } >>"$GIT_DIR"/COMMIT_EDITMSG
546 else
547         # we need to check if there is anything to commit
548         run_status >/dev/null 
549 fi
550 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
551 then
552         rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
553         run_status
554         exit 1
555 fi
556
557 case "$no_edit" in
558 '')
559         case "${VISUAL:-$EDITOR},$TERM" in
560         ,dumb)
561                 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
562                 echo >&2 "Please supply the commit log message using either"
563                 echo >&2 "-m or -F option.  A boilerplate log message has"
564                 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
565                 exit 1
566                 ;;
567         esac
568         git-var GIT_AUTHOR_IDENT > /dev/null  || die
569         git-var GIT_COMMITTER_IDENT > /dev/null  || die
570         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
571         ;;
572 esac
573
574 case "$verify" in
575 t)
576         if test -x "$GIT_DIR"/hooks/commit-msg
577         then
578                 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
579         fi
580 esac
581
582 if test -z "$no_edit"
583 then
584     sed -e '
585         /^diff --git a\/.*/{
586             s///
587             q
588         }
589         /^#/d
590     ' "$GIT_DIR"/COMMIT_EDITMSG
591 else
592     cat "$GIT_DIR"/COMMIT_EDITMSG
593 fi |
594 git-stripspace >"$GIT_DIR"/COMMIT_MSG
595
596 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
597         git-stripspace |
598         wc -l` &&
599    test 0 -lt $cnt
600 then
601         if test -z "$TMP_INDEX"
602         then
603                 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
604         else
605                 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
606                 rm -f "$TMP_INDEX"
607         fi &&
608         commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
609         rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
610         git-update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
611         rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
612         if test -f "$NEXT_INDEX"
613         then
614                 mv "$NEXT_INDEX" "$THIS_INDEX"
615         else
616                 : ;# happy
617         fi
618 else
619         echo >&2 "* no commit message?  aborting commit."
620         false
621 fi
622 ret="$?"
623 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
624 if test -d "$GIT_DIR/rr-cache"
625 then
626         git-rerere
627 fi
628
629 if test "$ret" = 0
630 then
631         if test -x "$GIT_DIR"/hooks/post-commit
632         then
633                 "$GIT_DIR"/hooks/post-commit
634         fi
635         if test -z "$quiet"
636         then
637                 echo "Created${initial_commit:+ initial} commit $commit"
638                 git-diff-tree --shortstat --summary --root --no-commit-id HEAD --
639         fi
640 fi
641
642 exit "$ret"